/**
  * This file was generated from model [Model1] on [Wed May 23 17:51:31 MSD 2007].
  * Do not change content of this file.
  */

#ifndef __Model1ModelEngine_H__
#define __Model1ModelEngine_H__

#include <e32def.h>
#include <f32file.h>
#include <s32file.h>

/* Forward declaration of model engine class */	
class CModel1ModelEngine;
/* Forward declaration of base state machine class */	
class CModel1BaseMachine;
/* Forward declaration of state machines from the model */	
class TADevice;

/* Include state machine context class header */	
#include "StateMachineContext.h"

/* Include used controlled objects classes headers */	
#include "device.ConsoleMechanism.h"
#include "device.MoneyMechanism.h"
#include "device.OutMechanism.h"
#include "device.PrintMechanism.h"

/******************************************
 Model engine class: Model1
 ******************************************/
class CModel1ModelEngine
    {
		friend class TADevice;

	public:
		static CModel1ModelEngine* NewL(
            device.ConsoleMechanism* aO1,
            device.MoneyMechanism* aO2,
            device.OutMechanism* aO3,
            device.PrintMechanism* aO4);

		static CModel1ModelEngine* NewLC(
            device.ConsoleMechanism* aO1,
            device.MoneyMechanism* aO2,
            device.OutMechanism* aO3,
            device.PrintMechanism* aO4);
		
		virtual ~CModel1ModelEngine();

	private:

		void ConstructL(
            device.ConsoleMechanism* aO1,
            device.MoneyMechanism* aO2,
            device.OutMechanism* aO3,
            device.PrintMechanism* aO4);

	public:
		enum EEvent
            {
            E1,
            E2,
            E3,
            E4,
            E5,
            E6,
            E7,
            ANY_OTHER
            };
	
		void HandleL(EEvent aEvent);
		
		TStateMachineContext& Context() {return iContext;}
				
		RWriteStream* Log() {return iLog;}

		const TDesC& EventName(EEvent anEvent) const;
		
	private:
		// State machine context
		TStateMachineContext iContext;
	
	    // Statemachines are owned by CModel1ModelEngine
		TADevice* iADevice;
		
		// Logger stream isn't owned by CAutoAnswererModelEngine
		RWriteStream* iLog;
	};

/**
 * Base state machine class for model: Model1
 */
class CModel1BaseMachine
	{
	public:
		/* Constructor of base state machine */
		CModel1BaseMachine(CModel1ModelEngine& aModel): iModel(aModel) {}
				
        virtual void HandleL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext) = 0;

	protected:
		CModel1ModelEngine& iModel;
		
		virtual const TDesC& MachineName() const = 0;
		
		/**
		 * Logging methods
		 */
		void DoLogL(TDesC& message);
		void LogBeginL(const TDesC& aStateName, CAutoAnswererModelEngine::EEvent aEvent);
		void LogTransiteL(const TDesC& aOldStateName, const TDesC& aNewStateName);
		void LogEndL(const TDesC& aStateName, CAutoAnswererModelEngine::EEvent aEvent);
		void LogActionBeginL(const TDesC& anIdentifier);
		void LogActionEndL(const TDesC& anIdentifier);
		void LogActionEndL(const TDesC& anIdentifier, TInt aValue);
	};

/******************************************
 State machine class: ADevice          
 ******************************************/
class TADevice: CModel1BaseMachine
	{
	public:
		/* Constructor of state machine ADevice */
		TADevice(CModel1ModelEngine& aModel): CModel1BaseMachine(aModel), iState(TOP) {}
		
        void HandleL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext);
		
        /* Controlled objects setters */
		void SetO1(device.ConsoleMechanism* aO1) {iO1 = aO1;}
		void SetO2(device.MoneyMechanism* aO2) {iO2 = aO2;}
		void SetO3(device.OutMechanism* aO3) {iO3 = aO3;}
		void SetO4(device.PrintMechanism* aO4) {iO4 = aO4;}


	private:
		enum EState 
            {
            A1__,
            A2________,
            S2,
            A4____,
            A5___,
            A6__,
            TOP,
            UNKNOWN_STATE
            };

        EState iState;

        /* Controlled objects */
		device.ConsoleMechanism* iO1;
		device.MoneyMechanism* iO2;
		device.OutMechanism* iO3;
		device.PrintMechanism* iO4;


		TBool IsStable(EState aState) const;
		EState GetSuperstate(EState aState) const;
		const TDesC& StateName(EState aState) const; 
		const TDesC& MachineName() const;
		EState TransiteOnEventL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext);
		EState TransiteToStableL(EState aState, TStateMachineContext& aContext);
		void EnterStateL(EState aState, TStateMachineContext& aContext);
		void InvokeSubmachinesL(CModel1ModelEngine::EEvent aEvent, TStateMachineContext& aContext);
	};

#endif // __Model1ModelEngine_H__