package device.ui;

public class EventHandler {
	public final static int CHOISE_CONSOLE = 1;

	public final static int MONEY_CONSOLE = 2;

	public final static int CHANGE_TICKET_CONSOLE = 3;

	public final static int MONEYBACK_CONSOLE = 4;

	public final static int OUTOFPAPER_CONSOLE = 5;

	public final static int MM_BADMONEY = 1;

	public final static int MM_ALLOWED = 2;

	public final static int MM_DISALLOWED = 3;

	public final static int OM_EMPTY = 1;

	public final static int OM_FILLED = 1;

	public static InterfaceBuilder interfaceBuilder = null;

	public static void switchConsoleState(int state) {
		interfaceBuilder.screen = state;
		interfaceBuilder.mainForm.repaint();
	}

	public static void switchMoneyMechanismState(int state) {
		InterfaceState.moneyEnabled = (state != MM_DISALLOWED);
		interfaceBuilder.mainForm.repaint();
	}

	public static void switchOutMechanism(int state) {
		InterfaceState.outMechanismState = state;
		interfaceBuilder.mainForm.repaint();
	}

	public static void switchPayButtonState(boolean state) {
		InterfaceState.payButtonState = state;
		if (state) {
			interfaceBuilder.btnPay.load("pay.png");
		} else {
			interfaceBuilder.btnPay.load("pay_NA.png");
		}
		interfaceBuilder.mainForm.repaint();
	}

	public static void refreshMoneyAmount(int amount) {
		InterfaceState.coinsIn = amount;
	}
}
