package device.ui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.JFrame;

import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;
import com.evelopers.unimod.core.stateworks.Event;

public class MainForm extends JFrame {
	static final long serialVersionUID = 2345723894503742L;

	InterfaceBuilder interfaceBuilder = new InterfaceBuilder();

	public EventHandler eventHandler;

	public ModelEngine engine = null;

	Image shadeBuffer;

	public MainForm(ModelEngine engine) {
		super("FahrTicketKasse");
		this.setResizable(false);
		setBounds(100, 50, interfaceBuilder.WIDTH, interfaceBuilder.HEIGHT);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);

		this.engine = engine;

		interfaceBuilder.loadInterface(this);

		EventHandler.interfaceBuilder = interfaceBuilder;

		shadeBuffer = createImage(interfaceBuilder.WIDTH,
				interfaceBuilder.HEIGHT);
	}

	public void paint(Graphics g) {
		if (shadeBuffer != null) {
			interfaceBuilder.render(shadeBuffer.getGraphics());
			g.drawImage(shadeBuffer, 0, 0, this);
		}
	}

	public void notify(String event) {
		engine.getEventManager().handle(new Event(event),
				StateMachineContextImpl.create());
	}
}
