package device.ui;

import java.awt.*;
import java.io.File;
import java.io.IOException;

public class MyButton {

	public final static int ACTIVE_COLOR = 65280;

	public String fileName;

	protected MyRegion btnRegion = null;

	Image buttonImage;

	boolean isActive = false;

	volatile boolean loaded = false;

	void setActive() {
		isActive = true;
	}

	void setPassive() {
		isActive = false;
	}

	public MyButton() {
		btnRegion = new MyRegion();
	}

	void load(String fileName) {
		MediaTracker tracker = new MediaTracker(new Container());
		if (fileName != "") {
			// D:\\Education\\Unimod\\unispace\\FahrTicketKasse\\
			String imageDirectory = "c:\\tools\\JSpace\\unispace\\FahrTicketKasse\\";
			File readfile = new File(imageDirectory + fileName);
			try {
				buttonImage = javax.imageio.ImageIO.read(readfile);
				tracker.addImage(buttonImage, 0);
				try {
					tracker.waitForID(0);
				} catch (InterruptedException ex1) {
				}
				this.fileName = fileName;
			} catch (IOException ex) {
				System.out.print("Image files haven't been found!");
				System.exit(0);
			}
			loaded = true;
			btnRegion.setWidth(buttonImage.getWidth(null));
			btnRegion.setHeight(buttonImage.getHeight(null));
		}
	}

	void setTheSameImage(MyButton btn) {
		buttonImage = btn.buttonImage;
		btnRegion.setWidth(buttonImage.getWidth(null));
		btnRegion.setHeight(buttonImage.getHeight(null));
	}

	boolean test(int x, int y) {
		return (x >= btnRegion.getLeft()
				&& x <= btnRegion.getLeft() + btnRegion.getWidth()
				&& y >= btnRegion.getTop() && y <= btnRegion.getTop()
				+ btnRegion.getHeight());
	}

	void draw(Graphics g) {
		g.drawImage(buttonImage, btnRegion.getLeft(), btnRegion.getTop(), null);
		if (isActive) {
			g.setColor(new Color(ACTIVE_COLOR));
			g.drawRect(btnRegion.getLeft(), btnRegion.getTop(), btnRegion
					.getWidth(), btnRegion.getHeight());
			g.setColor(new Color(0));
		}
	}

	public MyRegion getRegion() {
		return btnRegion;
	}

	public void applyLeftTopPosition(MyRegion btnRegion) {
		this.btnRegion.setLeft(btnRegion.getLeft());
		this.btnRegion.setTop(btnRegion.getTop());
	}
}
